/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Decoder.xs. Do not edit this file, edit Decoder.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Decoder.xs"
/* $Id: Decoder.xs 348 2005-07-14 02:32:46Z dsully $ */

#ifdef __cplusplus
"C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <errno.h>
#include <stdlib.h>

#ifdef _MSC_VER
# define alloca            _alloca
#endif

#include <vorbis/codec.h>
#include <vorbis/vorbisfile.h>

/* strlen the length automatically */
#define my_hv_store(a,b,c)   (void)hv_store(a,b,strlen(b),c,0)
#define my_hv_fetch(a,b)     hv_fetch(a,b,strlen(b),0)

#ifdef WORDS_BIGENDIAN
#define host_is_big_endian() TRUE
#else
#define host_is_big_endian() FALSE
#endif

int endian = host_is_big_endian();

static size_t ovcb_read(void *ptr, size_t size, size_t nmemb, void *datasource);
static int    ovcb_seek(void *datasource, ogg_int64_t offset, int whence);
static int    ovcb_close(void *datasource);
static long   ovcb_tell(void *datasource);

/* http://www.xiph.org/ogg/vorbis/doc/vorbisfile/ov_callbacks.html */
ov_callbacks vorbis_callbacks = {
	ovcb_read,
	ovcb_seek,
	ovcb_close,
	ovcb_tell
};

/* Allow multiple instances of the decoder object. Stuff each filehandle into (void*)stream */
typedef struct {
	int is_streaming;
	int bytes_streamed;
	int last_bitstream;
	PerlIO *stream;

} ocvb_datasource;

/* useful items from XMMS */
static size_t ovcb_read(void *ptr, size_t size, size_t nmemb, void *vdatasource) {

	size_t read_bytes = 0;

	ocvb_datasource *datasource = vdatasource;

	read_bytes = PerlIO_read(datasource->stream, ptr, size * nmemb);

	datasource->bytes_streamed += read_bytes;

	return read_bytes;
}

static int ovcb_seek(void *vdatasource, ogg_int64_t offset, int whence) {

	ocvb_datasource *datasource = vdatasource;

	if (datasource->is_streaming) {
		return -1;
	}

	/* For some reason PerlIO_seek fails miserably here. < 5.8.1 works */
	/* return PerlIO_seek(datasource->stream, offset, whence); */

	return fseek(PerlIO_findFILE(datasource->stream), offset, whence);
}

static int ovcb_close(void *vdatasource) {

	ocvb_datasource *datasource = vdatasource;

	return PerlIO_close(datasource->stream);
}

static long ovcb_tell(void *vdatasource) {

	ocvb_datasource *datasource = vdatasource;

	if (datasource->is_streaming) {
		return datasource->bytes_streamed;
	}

	return PerlIO_tell(datasource->stream);
}

/* Loads the commments from the stream and fills the object's hash */
void __read_comments(HV *self, OggVorbis_File *vf) {

	int i;
	char *half;

	/* XXX - rename these */
	HV *comments = newHV();
	SV *ts;
	AV *ta;

	vorbis_comment *vc = ov_comment(vf, -1);

	/* return early if there are no comments */
	if (!vc) return;

	for (i = 0; i < vc->comments; ++i) {

		half = strchr(vc->user_comments[i], '=');

		if (half == NULL) {
			warn("Comment \"%s\" missing \'=\', skipping...\n", vc->user_comments[i]);
			continue;
		}

		if (!hv_exists(comments, vc->user_comments[i], half - vc->user_comments[i])) {

			ta = newAV();
			ts = newRV_noinc((SV*) ta);

			(void)hv_store(comments, vc->user_comments[i], half - vc->user_comments[i], ts, 0);

		} else {

			ta = (AV*) SvRV(*(hv_fetch(comments, vc->user_comments[i], half - vc->user_comments[i], 0)));
		}

		av_push(ta, newSVpv(half + 1, 0));
	}

	my_hv_store(self, "COMMENTS", newRV_noinc((SV*) comments));
}

void __read_info(HV *self, OggVorbis_File *vf) {

	HV *info = newHV();

	vorbis_info *vi = ov_info(vf, -1);

	if (!vi) return;

	my_hv_store(info, "version", newSViv(vi->version));
	my_hv_store(info, "channels", newSViv(vi->channels));
	my_hv_store(info, "rate", newSViv(vi->rate));
	my_hv_store(info, "bitrate_upper", newSViv(vi->bitrate_upper));
	my_hv_store(info, "bitrate_nominal", newSViv(vi->bitrate_nominal));
	my_hv_store(info, "bitrate_lower", newSViv(vi->bitrate_lower));
	my_hv_store(info, "bitrate_window", newSViv(vi->bitrate_window));
	my_hv_store(info, "length", newSVnv(ov_time_total(vf, -1)));

	my_hv_store(self, "INFO", newRV_noinc((SV*) info));
}

#line 179 "Decoder.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 323 "Decoder.c"

XS_EUPXS(XS_Ogg__Vorbis__Decoder_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, path");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
	SV *	path = ST(1)
;
	SV *	RETVAL;
#line 177 "Decoder.xs"
	int ret;

	/* Create our new self and a ref to it - all of these are cleaned up
	 * in DESTROY by ov_clear() and safefree() */

	HV *self = newHV();
	SV *obj_ref = newRV_noinc((SV*) self);

	/* holder for the VF itself */
	OggVorbis_File *vf = (OggVorbis_File *) safemalloc(sizeof(OggVorbis_File));

	/* our stash for streams */
	ocvb_datasource *datasource = (ocvb_datasource *) safemalloc(sizeof(ocvb_datasource));
	memset(datasource, 0, sizeof(ocvb_datasource));

	/* check and see if a pathname was passed in, otherwise it might be a
	 * IO::Socket subclass, or even a *FH Glob */
	if (SvOK(path) && (SvTYPE(SvRV(path)) != SVt_PVGV)) {

		if ((datasource->stream = PerlIO_open((char*)SvPV_nolen(path), "r")) == NULL) {
			safefree(vf);
			printf("failed on open: [%d] - [%s]\n", errno, strerror(errno));
			XSRETURN_UNDEF;
		}

		datasource->is_streaming = 0;

	} else if (SvOK(path)) {

		/* Did we get a Glob, or a IO::Socket subclass?
		 *
		 * XXX This should really be a class method so the caller
		 * can tell us if it's streaming or not. But how to do this on
		 * a per object basis without changing open()s arugments. That
		 * may be the easiest/only way. XXX
		 *
		 */

		if (sv_isobject(path) && sv_derived_from(path, "IO::Socket")) {
			datasource->is_streaming = 1;
		} else {
			datasource->is_streaming = 0;
		}

		/* dereference and get the SV* that contains the Magic & FH,
		 * then pull the fd from the PerlIO object */
		datasource->stream = IoIFP(GvIOp(SvRV(path)));

	} else {

		XSRETURN_UNDEF;
	}

	if ((ret = ov_open_callbacks((void*)datasource, vf, NULL, 0, vorbis_callbacks)) < 0) {

		warn("Failed on registering callbacks: [%d]\n", ret);
		printf("failed on open: [%d] - [%s]\n", errno, strerror(errno));
		ov_clear(vf);
		XSRETURN_UNDEF;
        }

	datasource->bytes_streamed = 0;
	datasource->last_bitstream = -1;

	/* initalize bitrate, channels, etc */
	__read_info(self, vf);

	/* Values stored at base level */
	my_hv_store(self, "PATH", newSVsv(path));
	my_hv_store(self, "VFILE", newSViv((IV) vf));
	my_hv_store(self, "BSTREAM", newSViv(0));
	my_hv_store(self, "READCOMMENTS", newSViv(1));

	/* Bless the hashref to create a class object */
	sv_bless(obj_ref, gv_stashpv(class, FALSE));

	RETVAL = obj_ref;

#line 416 "Decoder.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_read)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "obj, buffer, nbytes = 4096, word = 2, sgned = 1");
    {
	SV*	obj = ST(0)
;
	SV*	buffer = ST(1)
;
	int	nbytes;
	int	word;
	int	sgned;
	long	RETVAL;
	dXSTARG;

	if (items < 3)
	    nbytes = 4096;
	else {
	    nbytes = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    word = 2;
	else {
	    word = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    sgned = 1;
	else {
	    sgned = (int)SvIV(ST(4))
;
	}
#line 270 "Decoder.xs"
	{
	int bytes = 0;
	int total_bytes_read = 0;
	int read_comments = 0;
	int old_bitstream, cur_bitstream;

	char *readBuffer = alloca(nbytes);

	/* for replay gain */
	/* not yet.. */
	int use_rg = 0;
	float ***pcm = NULL;

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	if (!vf) XSRETURN_UNDEF;

	if (ix) {
		/* empty */
	}

	/* See http://www.xiph.org/ogg/vorbis/doc/vorbisfile/ov_read.html for
	 * a description of the bitstream parameter. This allows streaming
	 * without a hack like icy-metaint */
	cur_bitstream = (int) SvIV(*(my_hv_fetch(self, "BSTREAM")));
	old_bitstream = cur_bitstream;

	/* When we get a new bitstream, re-read the comment fields */
	read_comments = (int)SvIV(*(my_hv_fetch(self, "READCOMMENTS")));

	/* The nbytes argument to ov_read is only a limit, not a request. So
	 * read until we hit the requested number of bytes */
	while (nbytes > 0) {

		if (use_rg) {

                	bytes = ov_read_float(vf, pcm, nbytes, &cur_bitstream);

                	if (bytes > 0) {
                        	/* bytes = vorbis_process_replaygain(pcm, bytes, channels, readBuffer, rg_scale); */
			}

		} else {

			bytes = ov_read(vf, readBuffer, nbytes, endian, word, sgned, &cur_bitstream);
		}

		if (bytes && read_comments != 0) {
			__read_comments(self, vf);
			read_comments = 0;
		}

		if (bytes == 0) {
			/* eof */
			break;

		} else if (bytes == OV_HOLE || bytes == OV_EBADLINK) {
			/* error in stream, but we don't care, move along */

		} else if (bytes < 0 && errno == EINTR) {
			/* try to re-read, same as above */

		} else if (bytes < 0) {
			/* error */
			break;

		} else {

			total_bytes_read += bytes;
			readBuffer += bytes;
			nbytes  -= bytes;

			/* did we enter a new logical bitstream? */
			if (old_bitstream != cur_bitstream && old_bitstream != -1) {

				__read_info(self, vf);
				read_comments = 1;
				break;
			}
		}
	}

	/* update with our new bitstream */
	sv_setiv(*my_hv_fetch(self, "BSTREAM"), (IV) cur_bitstream);
	sv_setiv(*my_hv_fetch(self, "READCOMMENTS"), (IV)read_comments);

	/* copy the buffer into our passed SV* */
	sv_setpvn(buffer, readBuffer-total_bytes_read, total_bytes_read);

	if (bytes < 0) XSRETURN_UNDEF;

	RETVAL = total_bytes_read;

	}

#line 559 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder__read_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder__read_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
#line 374 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	__read_info(self, vf);
#line 580 "Decoder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder__read_comments); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder__read_comments)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
#line 384 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	__read_comments(self, vf);
#line 600 "Decoder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
#line 394 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	ov_clear(vf);
	safefree(vf);
#line 621 "Decoder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_raw_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_raw_seek)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "obj, pos, whence = 0");
    {
	SV*	obj = ST(0)
;
	long	pos = (long)SvIV(ST(1))
;
	int	whence;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    whence = 0;
	else {
	    whence = (int)SvIV(ST(2))
;
	}
#line 411 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	/* XXX - handle whence */
	RETVAL = ov_raw_seek(vf, pos);

#line 655 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_pcm_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_pcm_seek)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "obj, pos, page = 0");
    {
	SV*	obj = ST(0)
;
	ogg_int64_t	pos = (ogg_int64_t)SvIV(ST(1))
;
	int	page;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    page = 0;
	else {
	    page = (int)SvIV(ST(2))
;
	}
#line 427 "Decoder.xs"
	{

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	if (page == 0) {
		RETVAL = ov_pcm_seek(vf, pos);
	} else {
		RETVAL = ov_pcm_seek_page(vf, pos);
	}

	}

#line 697 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_time_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_time_seek)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "obj, pos, page = 0");
    {
	SV*	obj = ST(0)
;
	double	pos = (double)SvNV(ST(1))
;
	int	page;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    page = 0;
	else {
	    page = (int)SvIV(ST(2))
;
	}
#line 450 "Decoder.xs"
	{

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	if (page == 0) {
		RETVAL = ov_time_seek(vf, pos);
	} else {
		RETVAL = ov_time_seek_page(vf, pos);
	}

	}

#line 739 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_bitrate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_bitrate)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "obj, i = -1");
    {
	SV*	obj = ST(0)
;
	int	i;
	long	RETVAL;
	dXSTARG;

	if (items < 2)
	    i = -1;
	else {
	    i = (int)SvIV(ST(1))
;
	}
#line 472 "Decoder.xs"
	{

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_bitrate(vf, i);

	}

#line 775 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_bitrate_instant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_bitrate_instant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	long	RETVAL;
	dXSTARG;
#line 489 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_bitrate_instant(vf);

#line 799 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_streams); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_streams)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	long	RETVAL;
	dXSTARG;
#line 502 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_streams(vf);

#line 823 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_seekable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_seekable)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	long	RETVAL;
	dXSTARG;
#line 515 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_seekable(vf);

#line 847 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_serialnumber); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_serialnumber)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "obj, i = -1");
    {
	SV*	obj = ST(0)
;
	int	i;
	long	RETVAL;
	dXSTARG;

	if (items < 2)
	    i = -1;
	else {
	    i = (int)SvIV(ST(1))
;
	}
#line 529 "Decoder.xs"
	{

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_serialnumber(vf, i);
	}

#line 882 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_raw_total); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_raw_total)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "obj, i = -1");
    {
	SV*	obj = ST(0)
;
	int	i;
	IV	RETVAL;
	dXSTARG;

	if (items < 2)
	    i = -1;
	else {
	    i = (int)SvIV(ST(1))
;
	}
#line 546 "Decoder.xs"
	{

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_raw_total(vf, i);

	}

#line 918 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_pcm_total); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_pcm_total)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "obj, i = -1");
    {
	SV*	obj = ST(0)
;
	int	i;
	IV	RETVAL;
	dXSTARG;

	if (items < 2)
	    i = -1;
	else {
	    i = (int)SvIV(ST(1))
;
	}
#line 564 "Decoder.xs"
	{

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_pcm_total(vf, i);

	}

#line 954 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_time_total); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_time_total)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "obj, i = -1");
    {
	SV*	obj = ST(0)
;
	int	i;
	double	RETVAL;
	dXSTARG;

	if (items < 2)
	    i = -1;
	else {
	    i = (int)SvIV(ST(1))
;
	}
#line 582 "Decoder.xs"
	{

	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_time_total(vf, i);

	}

#line 990 "Decoder.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_raw_tell); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_raw_tell)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	IV	RETVAL;
	dXSTARG;
#line 599 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_raw_tell(vf);

#line 1014 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_pcm_tell); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_pcm_tell)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	IV	RETVAL;
	dXSTARG;
#line 612 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_pcm_tell(vf);

#line 1038 "Decoder.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ogg__Vorbis__Decoder_time_tell); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ogg__Vorbis__Decoder_time_tell)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	double	RETVAL;
	dXSTARG;
#line 625 "Decoder.xs"
	HV *self = (HV *) SvRV(obj);
	OggVorbis_File *vf = (OggVorbis_File *) SvIV(*(my_hv_fetch(self, "VFILE")));

	RETVAL = ov_time_tell(vf);

#line 1062 "Decoder.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Ogg__Vorbis__Decoder); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Ogg__Vorbis__Decoder)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Ogg::Vorbis::Decoder::open", XS_Ogg__Vorbis__Decoder_open);
        cv = newXS_deffile("Ogg::Vorbis::Decoder::read", XS_Ogg__Vorbis__Decoder_read);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Ogg::Vorbis::Decoder::sysread", XS_Ogg__Vorbis__Decoder_read);
        XSANY.any_i32 = 1;
        newXS_deffile("Ogg::Vorbis::Decoder::_read_info", XS_Ogg__Vorbis__Decoder__read_info);
        newXS_deffile("Ogg::Vorbis::Decoder::_read_comments", XS_Ogg__Vorbis__Decoder__read_comments);
        newXS_deffile("Ogg::Vorbis::Decoder::DESTROY", XS_Ogg__Vorbis__Decoder_DESTROY);
        newXS_deffile("Ogg::Vorbis::Decoder::raw_seek", XS_Ogg__Vorbis__Decoder_raw_seek);
        newXS_deffile("Ogg::Vorbis::Decoder::pcm_seek", XS_Ogg__Vorbis__Decoder_pcm_seek);
        newXS_deffile("Ogg::Vorbis::Decoder::time_seek", XS_Ogg__Vorbis__Decoder_time_seek);
        newXS_deffile("Ogg::Vorbis::Decoder::bitrate", XS_Ogg__Vorbis__Decoder_bitrate);
        newXS_deffile("Ogg::Vorbis::Decoder::bitrate_instant", XS_Ogg__Vorbis__Decoder_bitrate_instant);
        newXS_deffile("Ogg::Vorbis::Decoder::streams", XS_Ogg__Vorbis__Decoder_streams);
        newXS_deffile("Ogg::Vorbis::Decoder::seekable", XS_Ogg__Vorbis__Decoder_seekable);
        newXS_deffile("Ogg::Vorbis::Decoder::serialnumber", XS_Ogg__Vorbis__Decoder_serialnumber);
        newXS_deffile("Ogg::Vorbis::Decoder::raw_total", XS_Ogg__Vorbis__Decoder_raw_total);
        newXS_deffile("Ogg::Vorbis::Decoder::pcm_total", XS_Ogg__Vorbis__Decoder_pcm_total);
        newXS_deffile("Ogg::Vorbis::Decoder::time_total", XS_Ogg__Vorbis__Decoder_time_total);
        newXS_deffile("Ogg::Vorbis::Decoder::raw_tell", XS_Ogg__Vorbis__Decoder_raw_tell);
        newXS_deffile("Ogg::Vorbis::Decoder::pcm_tell", XS_Ogg__Vorbis__Decoder_pcm_tell);
        newXS_deffile("Ogg::Vorbis::Decoder::time_tell", XS_Ogg__Vorbis__Decoder_time_tell);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

